Sketcher#

Sketcher commands are used to define the entities, such as the geometry, constraints, and dimensions, to create a sketch and to store the values and attributes associated with a particular sketch.

Create constrained sketches#

class SketchModel(name: str, description: str = '', stefanBoltzmann: float | None = None, absoluteZero: float | None = None, waveFormulation: SymbolicConstantType = 'NOT_SET', modelType: SymbolicConstantType = 'STANDARD_EXPLICIT', universalGas: float | None = None, copyConstraints: BooleanType = 1, copyConnectors: BooleanType = 1, copyInteractions: BooleanType = 1)[source]#

Abaqus creates a Model object named Model-1 when a session is started.

Notes

This object can be accessed by:

mdb.models[name]

Methods

ConstrainedSketch(name, sheetSize[, ...])

This method creates a ConstrainedSketch object.

ConstrainedSketch(name: str, sheetSize: float, gridSpacing: float | None = None, transform: tuple = ()) ConstrainedSketch[source]#

This method creates a ConstrainedSketch object. If the sketch cannot be created, the method returns None.

Parameters:
name

A String specifying the repository key.

sheetSize

A Float specifying the sheet size.

gridSpacing

A Float specifying the spacing between gridlines. Possible values are Floats >> 0. The default value is approximately 2 percent of sheetSize.

transform

A sequence of sequences of Floats specifying the three-dimensional orientation of the sketch. The sequence is a 3 × 4 transformation matrix specifying the axis of rotation and the translation vector. Possible values are any Floats.The default value for the axis of rotation is the identity matrix`(1.0, 0.0, 0.0), (0.0, 1.0, 0.0), (0.0, 0.0, 1.0)`The default value for the translation vector is`(0.0, 0.0, 0.0)`The default values position the sketch on the X–Y plane centered at the origin.

Returns:
sketch: ConstrainedSketch

A ConstrainedSketch object.

Notes

This function can be accessed by:

mdb.models[name].ConstrainedSketch

Object features#

ConstrainedSketch#

class ConstrainedSketch(name: str, sheetSize: float, gridSpacing: float = None, transform: tuple = ())[source]#
class ConstrainedSketch(name: str, objectToCopy: ConstrainedSketch)

Methods

ConstrainedSketchFromGeometryFile(name, ...)

This method creates a ConstrainedSketch object and places it in the sketches repository.

assignCenterOfTwist(point)

This method indicates the isolated point that will be used as the center of twist when an extruded feature is created with twist.

assignCenterline(line)

This method indicates the construction line that will be used as a centerline for revolved features.

autoDimension(objectList)

This method applies dimensions to the selected ConstrainedSketchGeometry objects in an effort to make the ConstrainedSketch well defined.

autoTrimCurve(curve1, point1, parameter1)

This method automatically trims a selected ConstrainedSketchGeometry object at the specified location.

breakCurve(curve1, point1, curve2, point2)

This method breaks a specified ConstrainedSketchGeometry object (curve1) using another specified ConstrainedSketchGeometry object (curve2).

copyMirror(mirrorLine, objectList)

This method creates copies of the given ConstrainedSketchGeometry objects, mirrors them about a selected line, and inserts them into the appropriate repositories of the ConstrainedSketch object.

copyMove(vector, objectList)

This method creates copies of the given ConstrainedSketchGeometry objects, moves them from their original position, and inserts them into the appropriate repositories of the ConstrainedSketch object.

copyRotate(centerPoint, angle, objectList)

This method creates copies of the given ConstrainedSketchGeometry objects, rotates them, and inserts them into the appropriate repositories of the ConstrainedSketch object.

copyScale(scaleValue, scaleCenter, objectList)

This method creates copies of the given ConstrainedSketchGeometry objects, scales them by the specified value about a selected point, and inserts them into the appropriate repositories of the ConstrainedSketch object.

delete(objectList)

This method deletes the given ConstrainedSketchGeometry, ConstrainedSketchDimension, or ConstrainedSketchConstraint objects.

deleteParameter(name)

The command deletes a specified parameter.

dragEntity(entity, points)

This method drags a specified ConstrainedSketchGeometry or ConstrainedSketchVertex object to a specific location.

linearPattern(number1, spacing1, angle1[, ...])

This method copies ConstrainedSketchGeometry objects in a linear pattern along one or two directions.

mergeVertices(value, vertexList)

This method merges the ConstrainedSketchVertex objects that lie within the specified distance of each other.

move(vector, objectList)

This method translates the given ConstrainedSketchGeometry objects by the given vector.

offset(distance, objectList, side[, ...])

This method creates copies of the selected ConstrainedSketchGeometry objects, offsets them by the specified distance in the specified direction, and inserts them into the ConstrainedSketch object's appropriate repositories.

print()

This method prints the following statistics about a sketch: - The sketch Id (a positive integer).

radialPattern(number, totalAngle, centerPoint)

This method copies ConstrainedSketchGeometry objects in a radial pattern about a specified center point.

rectangle(point1, point2)

This method creates four lines that form a rectangle with diagonal corners defined by the given points and inserts them into the geometry repository of the ConstrainedSketch object.

removeGapsAndOverlaps(tolerance, geomList)

This method removes gaps and overlaps between sketch geometries specified by the user.

repairShortEdges(geomList[, tolerance])

This method deletes the short edges specified, optionally selecting only those short edges whose lengths are smaller than the specified tolerance and healing the resultant gap in the sketch.

resetView()

This method resets the view to be perpendicular to the sketching plane.

retrieveSketch(sketch)

This method copies all ConstrainedSketchGeometry, ConstrainedSketchDimension, ConstrainedSketchConstraint, and ConstrainedSketchParameter objects from the specified ConstrainedSketch object.

rotate(centerPoint, angle, objectList)

This method rotates the given ConstrainedSketchGeometry objects by the given angle and about the given point.

scale(scaleValue, scaleCenter, objectList)

This method scales the given ConstrainedSketchGeometry objects by the given scale factor and about the given point.

setPrimaryObject(option)

This method makes the ConstrainedSketch object the primary object in the current viewport.

trimExtendCurve(curve1, point1, curve2, point2)

This method trims or extends a specified ConstrainedSketchGeometry object (curve1) using another specified ConstrainedSketchGeometry object (curve2).

undo()

This method undoes the effects of the last ConstrainedSketch object method.

unsetPrimaryObject()

This method removes the ConstrainedSketch object from the current viewport, reversing the effects of the setPrimaryobject command.

writeAcisFile(fileName[, version])

This method exports the geometry of the sketch to a named file in ACIS format.

writeIgesFile(filename[, flavor])

This method exports the geometry of the sketch to a named file in IGES format.

AngularDimension(line1: ConstrainedSketchGeometry, line2: ConstrainedSketchGeometry, textPoint: tuple[float], value: float | None = None, reference: BooleanType = 0)[source]#

This method constructs a ConstrainedSketchDimension object between two ConstrainedSketchGeometry objects, with the given angle between them.

Parameters:
line1

A ConstrainedSketchGeometry object specifying the first line.

line2

A ConstrainedSketchGeometry object specifying the second line.

textPoint

A pair of Floats specifying the location of the dimension text.

value

A Float specifying the angle between the two lines.

reference

A Boolean specifying whether the created dimension enforces the above value or if it simply measures the angle between two lines.

Returns:
dimension

A ConstrainedSketchDimension object

Notes

This function can be accessed by:

mdb.models[name].sketches[name].AngularDimension
Arc3Points(point1: tuple[float], point2: tuple[float], point3: tuple[float])[source]#

This method constructs an arc using a two endpoints and an intermediate third point on the arc.

Parameters:
point1

A pair of Floats specifying the first endpoint of the arc.

point2

A pair of Floats specifying the second endpoint of the arc.

point3

A pair of Floats specifying the third point on the arc.

Returns:
geometry: ConstrainedSketchGeometry

A ConstrainedSketchGeometry object

Notes

This function can be accessed by:

mdb.models[name].sketches[name].Arc3Points
ArcByCenterEnds(center: tuple[float], point1: tuple[float], point2: tuple[float], direction: SymbolicConstantType)[source]#

This method constructs an arc using a center point and two vertices. The Arc object is added to the geometry repository of the ConstrainedSketch object. The arc is created in a clockwise fashion from point1 to point2.

Parameters:
center

A pair of Floats specifying the center point of the arc.

point1

A pair of Floats specifying the first endpoint of the arc.

point2

A pair of Floats specifying the second endpoint of the arc.

direction

A SymbolicConstant specifying the direction of the arc. Possible values are CLOCKWISE and COUNTERCLOCKWISE.

Returns:
geometry: ConstrainedSketchGeometry

A ConstrainedSketchGeometry object

Raises:
If incompatible data are given, the second endpoint is ignored

Notes

This function can be accessed by:

mdb.models[name].sketches[name].ArcByCenterEnds
ArcByStartEndTangent(point1: tuple[float], point2: tuple[float], vector: tuple)[source]#

This method constructs an arc using two vertices. The Arc object is added to the geometry repository of the ConstrainedSketch object.

Parameters:
point1

A pair of Floats specifying the first endpoint of the arc.

point2

A pair of Floats specifying the second endpoint of the arc.

vector

A sequence of two Floats specifying the start direction for constructing the arc.

Returns:
geometry: ConstrainedSketchGeometry

A ConstrainedSketchGeometry object

Notes

This function can be accessed by:

mdb.models[name].sketches[name].ArcByStartEndTangent
CircleByCenterPerimeter(center: tuple[float], point1: tuple[float])[source]#

This method constructs a circle using a center point and a point on the perimeter. The circle is added to the geometry repository of the ConstrainedSketch object.

Parameters:
center

A pair of Floats specifying the center point of the circle.

point1

A pair of Floats specifying a point on the perimeter of the circle.

Returns:
geometry: ConstrainedSketchGeometry

A ConstrainedSketchGeometry object

Notes

This function can be accessed by:

mdb.models[name].sketches[name].CircleByCenterPerimeter
CoincidentConstraint(entity1: ConstrainedSketchGeometry, entity2: ConstrainedSketchGeometry)[source]#

This method creates a coincident constraint. This constraint applies to two vertices, to a vertex and a ConstrainedSketchGeometry object, or to two ConstrainedSketchGeometry objects of the same type and constrains them to be coincident.

Parameters:
entity1

A ConstrainedSketchGeometry object or a ConstrainedSketchVertex object specifying the first object.

entity2

A ConstrainedSketchGeometry object or a ConstrainedSketchVertex object specifying the second object.

Returns:
sketch: ConstrainedSketch

A ConstrainedSketch object

Notes

This function can be accessed by:

mdb.models[name].sketches[name].CoincidentConstraint
ConcentricConstraint(entity1: ConstrainedSketchGeometry, entity2: ConstrainedSketchGeometry)[source]#

This method creates a concentric constraint. This constraint applies to any combination of circles, arcs, ellipses, and points and constrains them to be concentric. A concentric constraint implies that the center of ConstrainedSketchGeometry objects coincide.

Parameters:
entity1

A ConstrainedSketchGeometry object specifying the first arc, circle, ellipse, or sketch vertex.

entity2

A ConstrainedSketchGeometry object specifying the second arc, circle, ellipse, or sketch vertex.

Returns:
sketch: ConstrainedSketch

A ConstrainedSketch object

Notes

This function can be accessed by:

mdb.models[name].sketches[name].ConcentricConstraint
ConstrainedSketchFromGeometryFile(name: str, geometryFile: AcisFile)[source]#

This method creates a ConstrainedSketch object and places it in the sketches repository.

Parameters:
name

A String specifying the repository key.

geometryFile

An AcisFile object specifying a file containing geometry. The geometry in the file is converted to two-dimensional sketch geometry in the X–Y plane.

Returns:
sketch: ConstrainedSketch

A ConstrainedSketch object

Notes

This function can be accessed by:

mdb.models[name].ConstrainedSketchFromGeometryFile
ConstrainedSketchParameter(name: str, path: str = '', expression: str = '', previousParameter: str = '')[source]#

This method creates a parameter and optionally associates a dimension with this parameter.

Parameters:
name

A String specifying the name of the ConstrainedSketchParameter object. No two parameters in the same ConstrainedSketch can have the same name.

path

A String specifying the ConstrainedSketchDimension object with which this parameter is associated.

expression

A String specifying the expression or value associated with the ConstrainedSketchParameter.

previousParameter

A String specifying the name of the previous ConstrainedSketchParameter, if it exists. The previousParameter argument implies an order among the parameters. No two parameters can reference the same parameter as the previous parameter.

Returns:
obj: ConstrainedSketchParameter

A ConstrainedSketchParameter object

Notes

This function can be accessed by:

mdb.models[name].sketches[name].ConstrainedSketchParameter
ConstructionCircleByCenterPerimeter(center: tuple[float], point1: tuple[float])[source]#

This method constructs a construction circle using a center point and a point on the perimeter. The circle is added to the geometry repository of the ConstrainedSketch object.

Parameters:
center

A pair of Floats specifying the center point of the construction circle.

point1

A pair of Floats specifying a point on the perimeter of the construction circle.

Returns:
geometry: ConstrainedSketchGeometry

A ConstrainedSketchGeometry object

Notes

This function can be accessed by:

mdb.models[name].sketches[name].ConstructionCircleByCenterPerimeter
ConstructionLine(point1: tuple[float], point2: tuple[float])[source]#

This method creates an oblique construction line that runs between two given points.

Parameters:
point1

A pair of Floats specifying the first endpoint.

point2

A pair of Floats specifying the second endpoint.

Returns:
geometry: ConstrainedSketchGeometry

A ConstrainedSketchGeometry object

Notes

This function can be accessed by:

mdb.models[name].sketches[name].ConstructionLine
DistanceDimension(entity1: ConstrainedSketchVertex, entity2: ConstrainedSketchVertex, textPoint: tuple[float], value: float | None = None, reference: BooleanType = 0)[source]#

This method constructs a ConstrainedSketchDimension object between two ConstrainedSketchGeometry, or aConstrainedSketchVertex and ConstrainedSketchGeometry object. A distance dimension specifies the shortest distance between two entities.

Parameters:
entity1

A ConstrainedSketchVertex object or ConstrainedSketchGeometry object.

entity2

A ConstrainedSketchVertex object or ConstrainedSketchGeometry object.

textPoint

A pair of Floats specifying the location of the dimension text.

value

A Float specifying the angle between the two lines.

reference

A Boolean specifying whether the created dimension enforces the above value or if it simply measures the angle between two lines.

Returns:
dimension

A ConstrainedSketchDimension object

Notes

This function can be accessed by:

mdb.models[name].sketches[name].DistanceDimension
EllipseByCenterPerimeter(center: tuple[float], axisPoint1: tuple[float], axisPoint2: tuple[float])[source]#

This method constructs an ellipse using a center point, a major axis point, and a minor axis point. The ellipse is added to the geometry repository of the ConstrainedSketch object.

Parameters:
center

A pair of Floats specifying the center point of the ellipse.

axisPoint1

A pair of Floats specifying the major or minor axis point of the ellipse.

axisPoint2

A pair of Floats specifying the minor or major axis point of the ellipse.

Returns:
geometry: ConstrainedSketchGeometry

A ConstrainedSketchGeometry object

Notes

This function can be accessed by:

mdb.models[name].sketches[name].EllipseByCenterPerimeter
EqualDistanceConstraint(entity1: str, entity2: ConstrainedSketchGeometry, midpoint: Vertex)[source]#

This method creates an equal distance constraint. This constraint can be applied between a midpoint ConstrainedSketchVertex object and any other two ConstrainedSketchVertex objects or between a midpoint ConstrainedSketchVertex object and two ConstrainedSketchGeometry objects that are lines. The equal distance constraint forces the midpoint vertex to remain at an equal distance from the two other vertices or lines.

Parameters:
entity1

AConstrainedSketchGeometry object specifying the first line or ConstrainedSketchVertex object.

entity2

A ConstrainedSketchGeometry object specifying the second line or ConstrainedSketchVertex object.

midpoint

A ConstrainedSketchVertex object specifying the vertex that will be positioned an equal distance from entity1 and entity2.

Returns:
sketch: ConstrainedSketch

A ConstrainedSketch object

Notes

This function can be accessed by:

mdb.models[name].sketches[name].EqualDistanceConstraint
EqualLengthConstraint(entity1: ConstrainedSketchGeometry, entity2: ConstrainedSketchGeometry)[source]#

This method creates an equal length constraint. This constraint applies to lines and constrains them such that their lengths are equal.

Parameters:
entity1

A ConstrainedSketchGeometry object specifying the first line.

entity2

A ConstrainedSketchGeometry object specifying the second line.

Returns:
sketch: ConstrainedSketch

A ConstrainedSketch object

Notes

This function can be accessed by:

mdb.models[name].sketches[name].EqualLengthConstraint
EqualRadiusConstraint(entity1: ConstrainedSketchGeometry, entity2: str)[source]#

This method creates an equal radius constraint. This constraint applies to circles and arcs and constrains them such that their radii are equal.

Parameters:
entity1

A ConstrainedSketchGeometry object specifying the first arc or circle.

entity2

A ConstrainedSketchGeometry specifying the second arc or circle.

Returns:
sketch: ConstrainedSketch

A ConstrainedSketch object

Notes

This function can be accessed by:

mdb.models[name].sketches[name].EqualRadiusConstraint
FilletByRadius(radius: float, curve1: ConstrainedSketchGeometryModel, nearPoint1: tuple[float], curve2: ConstrainedSketchGeometryModel, nearPoint2: tuple[float])[source]#

This method constructs a fillet arc of a given radius between two curves. The fillet is added to the geometry repository of the ConstrainedSketch object.

Parameters:
radius

A Float specifying the radius of the fillet arc. Possible values are Floats > 0.

curve1

A ConstrainedSketchGeometry object specifying the first curve.

nearPoint1

A pair of Floats specifying a point on the sketch near where the user wishes the fillet to intersect with curve1. This point does not need to be on*curve1*; it is used as a hint to draw the fillet.

curve2

A ConstrainedSketchGeometry object specifying the second curve.

nearPoint2

A pair of Floats specifying a point on the sketch near where the user wishes the fillet to intersect with curve2. This point does not need to be on curve2; it is used as a hint to draw the fillet.

Returns:
geometry: ConstrainedSketchGeometry

A ConstrainedSketchGeometry object

Raises:
  • If the radius given cannot be used to create a fillet between the two curves given:

    Range Error: cannot construct the Fillet specified

Notes

This function can be accessed by:

mdb.models[name].sketches[name].FilletByRadius
FixedConstraint(entity: ConstrainedSketchGeometry)[source]#

This method creates a fixed constraint. This constraint applies to a ConstrainedSketchGeometry object or a ConstrainedSketchVertex object and constrains them to be fixed in space. Both the location and the shape of the sketch geometry is fixed.

Parameters:
entity

A ConstrainedSketchGeometry object or a ConstrainedSketchVertex object specifying the item to fix in space.

Returns:
sketch: ConstrainedSketch

A ConstrainedSketch object

Notes

This function can be accessed by:

mdb.models[name].sketches[name].FixedConstraint
HorizontalConstraint(entity: ConstrainedSketchGeometry)[source]#

This method creates a horizontal constraint. This constraint applies to a line and constrains it to be horizontal.

Parameters:
entity

A ConstrainedSketchGeometry object specifying the line to constrain.

Returns:
sketch: ConstrainedSketch

A ConstrainedSketch object

Notes

This function can be accessed by:

mdb.models[name].sketches[name].HorizontalConstraint
HorizontalDimension(vertex1: ConstrainedSketchVertex, vertex2: ConstrainedSketchVertex, textPoint: tuple[float], value: float | None = None, reference: BooleanType = 0)[source]#

This method constructs a ConstrainedSketchDimension object between two vertices. A horizontal dimension indicates the horizontal distance along the X-axis between two vertices.

Parameters:
vertex1

A ConstrainedSketchVertex object specifying the first endpoint.

vertex2

A ConstrainedSketchVertex object specifying the second endpoint.

textPoint

A pair of Floats specifying the location of the dimension text.

value

A Float distance between the two vertices.

reference

A Boolean specifying whether the created dimension enforces the above value or if it simply measures the distance between the two vertices.

Returns:
dimension

A ConstrainedSketchDimension object

Notes

This function can be accessed by:

mdb.models[name].sketches[name].HorizontalDimension
Line(point1: tuple[float], point2: tuple[float])[source]#

This method creates a line between two given points.

Parameters:
point1

A pair of Floats specifying the first endpoint.

point2

A pair of Floats specifying the second endpoint.

Returns:
geometry: ConstrainedSketchGeometry

A ConstrainedSketchGeometry object

Notes

This function can be accessed by:

mdb.models[name].sketches[name].Line
ObliqueDimension(vertex1: ConstrainedSketchVertex, vertex2: ConstrainedSketchVertex, textPoint: tuple[float], value: float | None = None, reference: BooleanType = 0)[source]#

This method constructs a ConstrainedSketchDimension object between two vertices. An oblique dimension indicates the distance between two vertices.

Parameters:
vertex1

A ConstrainedSketchVertex object specifying the first endpoint.

vertex2

A ConstrainedSketchVertex object specifying the second endpoint.

textPoint

A pair of Floats specifying the location of the dimension text.

value

A Float specifying the distance between the two ConstrainedSketchVertex objects.

reference

A Boolean specifying whether the created dimension enforces the above value or if it simply measures the distance between the two vertices.

Returns:
dimension

A ConstrainedSketchDimension object

Notes

This function can be accessed by:

mdb.models[name].sketches[name].ObliqueDimension
ParallelConstraint(entity1: ConstrainedSketchGeometry, entity2: ConstrainedSketchGeometry)[source]#

This method creates a parallel constraint. This constraint applies to lines and constrains them to be parallel.

Parameters:
entity1

A ConstrainedSketchGeometry object specifying the first line.

entity2

A ConstrainedSketchGeometry object specifying the second line.

Returns:
sketch: ConstrainedSketch

A ConstrainedSketch object

Notes

This function can be accessed by:

mdb.models[name].sketches[name].ParallelConstraint
PerpendicularConstraint(entity1: ConstrainedSketchGeometry, entity2: ConstrainedSketchGeometry)[source]#

This method creates a perpendicular constraint. This constraint applies to different types of ConstrainedSketchGeometry objects and constrains them to be perpendicular to each other.

Parameters:
entity1

A ConstrainedSketchGeometry object specifying the first object.

entity2

A ConstrainedSketchGeometry object specifying the second object.

Returns:
sketch: ConstrainedSketch

A ConstrainedSketch object

Notes

This function can be accessed by:

mdb.models[name].sketches[name].PerpendicularConstraint
RadialDimension(curve: ConstrainedSketchGeometry, textPoint: tuple[float], value: float | None = None, reference: BooleanType = 0, majorRadius: float | None = None, minorRadius: float | None = None)[source]#

This method constructs a ConstrainedSketchDimension object on a circular or elliptical arc. A radial dimension indicates the radius of an arc or circle or the major or minor radius of an ellipse.

Parameters:
curve

A ConstrainedSketchGeometry object specifying the circular or elliptical arc.

textPoint

A pair of Floats specifying the location of the dimension text.

value

A Float specifying the radius of the arc, circle or ellipse.

reference

A Boolean specifying whether the created dimension enforces the above value or if it simply measures the angle between two lines.

majorRadius

A Float specifying the major Radius if curve is an ellipse. This is mutually exclusive with value and minorRadius.

minorRadius

A Float specifying the minor Radius if curve is an ellipse. This is mutually exclusive with value and majorRadius.

Returns:
dimension

A ConstrainedSketchDimension object

Notes

This function can be accessed by:

mdb.models[name].sketches[name].RadialDimension
Spline(points: tuple, constrainPoints: BooleanType = True)[source]#

This method creates a spline curve running through a sequence of points.

Parameters:
points

A sequence of pairs of Floats specifying the points through which the spline passes.

constrainPoints

A Boolean that determines whether the points given are to constrained to always remain on the Spline. The default is True. For a large sequence of points, significant performance gains may be achieved by setting the value to False.

Returns:
geometry: ConstrainedSketchGeometry

A ConstrainedSketchGeometry object

Notes

This function can be accessed by:

mdb.models[name].sketches[name].Spline
Spot(point: tuple[float])[source]#

This method creates a spot construction point located at the specified coordinates. The spot is added to the vertex repository of the ConstrainedSketch object.

Parameters:
point

A pair of Floats specifying the coordinates of the spot construction point.

Returns:
geometry: ConstrainedSketchGeometry

A ConstrainedSketchGeometry object

Notes

This function can be accessed by:

mdb.models[name].sketches[name].Spot
TangentConstraint(entity1: ConstrainedSketchGeometry, entity2: ConstrainedSketchGeometry)[source]#

This method creates a tangent constraint. This constraint applies to different types of ConstrainedSketchGeometry objects and constrains them to remain tangential.

Parameters:
entity1

A ConstrainedSketchGeometry object specifying the first object.

entity2

A ConstrainedSketchGeometry object specifying the second object.

Returns:
sketch: ConstrainedSketch

A ConstrainedSketch object

Notes

This function can be accessed by:

mdb.models[name].sketches[name].TangentConstraint
VerticalConstraint(entity: ConstrainedSketchGeometry)[source]#

This method creates a vertical constraint. This constraint applies to a line and constrains it to be vertical.

Parameters:
entity

A ConstrainedSketchGeometry object specifying the line to constrain.

Returns:
sketch: ConstrainedSketch

A ConstrainedSketch object

Notes

This function can be accessed by:

mdb.models[name].sketches[name].VerticalConstraint
VerticalDimension(vertex1: ConstrainedSketchVertex, vertex2: ConstrainedSketchVertex, textPoint: tuple[float], value: float | None = None, reference: BooleanType = 0)[source]#

This method constructs a ConstrainedSketchDimension between two vertices. A vertical dimension controls the vertical distance along the Y-axis between two vertices.

Parameters:
vertex1

A ConstrainedSketchVertex object specifying the first endpoint.

vertex2

A ConstrainedSketchVertex object specifying the second endpoint.

textPoint

A pair of Floats specifying the location of the dimension text.

value

A Float specifying the angle between the two lines.

reference

A Boolean specifying whether the created dimension enforces the above value or if it simply measures the angle between two lines.

Returns:
dimension

A ConstrainedSketchDimension object

Notes

This function can be accessed by:

mdb.models[name].sketches[name].VerticalDimension
assignCenterOfTwist(point: ConstrainedSketchVertex)[source]#

This method indicates the isolated point that will be used as the center of twist when an extruded feature is created with twist.

Parameters:
point

A ConstrainedSketchVertex object specifying an isolated point that indicates the center of twist for extruded features that use a twist angle.

assignCenterline(line: ConstrainedSketchGeometry)[source]#

This method indicates the construction line that will be used as a centerline for revolved features.

Parameters:
line

A ConstrainedSketchGeometry object specifying a construction line that indicates the centerline of revolved features.

autoDimension(objectList: tuple)[source]#

This method applies dimensions to the selected ConstrainedSketchGeometry objects in an effort to make the ConstrainedSketch well defined.

Parameters:
objectList

A sequence specifying the ConstrainedSketchGeometry objects to dimension.

autoTrimCurve(curve1: str, point1: tuple[float], parameter1: float)[source]#

This method automatically trims a selected ConstrainedSketchGeometry object at the specified location. If the object does not intersect other ConstrainedSketchGeometry objects, the entire selected object will be deleted.

Parameters:
curve1

The ConstrainedSketchGeometry object to be trimmed.

point1

A pair of Floats specifying the location on ConstrainedSketchGeometry where the trimming should be applied. point1 and parameter1 are mutually exclusive.

parameter1

A Float specifying the parameter location on the ConstrainedSketchGeometry where the trimming should be applied. point1 and parameter1 are mutually exclusive.

breakCurve(curve1: ConstrainedSketchGeometry, point1: tuple[float], curve2: ConstrainedSketchGeometry, point2: tuple[float])[source]#

This method breaks a specified ConstrainedSketchGeometry object (curve1) using another specified ConstrainedSketchGeometry object (curve2). If the selected ConstrainedSketchGeometry objects intersect, then only curve1 will be broken; curve2 is not affected by the operation. The location for the break is determined by the specified point values.

Parameters:
curve1

A ConstrainedSketchGeometry object specifying the object to be broken.

point1

A pair of Floats specifying the location on curve1 near where the break should be applied.

curve2

A ConstrainedSketchGeometry object specifying where curve1 should be broken.

point2

A pair of Floats specifying the location on curve2 near where curve1 should be broken.

copyMirror(mirrorLine: ConstrainedSketchGeometry, objectList: tuple[abaqus.Sketcher.ConstrainedSketchGeometry.ConstrainedSketchGeometry.ConstrainedSketchGeometry])[source]#

This method creates copies of the given ConstrainedSketchGeometry objects, mirrors them about a selected line, and inserts them into the appropriate repositories of the ConstrainedSketch object.

Parameters:
mirrorLine

A ConstrainedSketchGeometry object specifying the line about which Abaqus will mirror the sketch.

objectList

A sequence of ConstrainedSketchGeometry objects specifying the sketch to be copied and mirrored.

copyMove(vector: tuple, objectList: tuple[abaqus.Sketcher.ConstrainedSketchGeometry.ConstrainedSketchGeometry.ConstrainedSketchGeometry])[source]#

This method creates copies of the given ConstrainedSketchGeometry objects, moves them from their original position, and inserts them into the appropriate repositories of the ConstrainedSketch object.

Parameters:
vector

A sequence of two Floats specifying the translation vector.

objectList

A sequence of ConstrainedSketchGeometry objects to be copied and moved.

copyRotate(centerPoint: tuple[float], angle: float, objectList: tuple[abaqus.Sketcher.ConstrainedSketchGeometry.ConstrainedSketchGeometry.ConstrainedSketchGeometry])[source]#

This method creates copies of the given ConstrainedSketchGeometry objects, rotates them, and inserts them into the appropriate repositories of the ConstrainedSketch object.

Parameters:
centerPoint

A pair of Floats specifying the center of rotation.

angle

A Float specifying the angle of rotation in degrees.

objectList

A sequence of ConstrainedSketchGeometry objects to be copied and moved.

copyScale(scaleValue: float, scaleCenter: tuple[float], objectList: tuple[abaqus.Sketcher.ConstrainedSketchGeometry.ConstrainedSketchGeometry.ConstrainedSketchGeometry])[source]#

This method creates copies of the given ConstrainedSketchGeometry objects, scales them by the specified value about a selected point, and inserts them into the appropriate repositories of the ConstrainedSketch object.

Parameters:
scaleValue

A Float specifying the value for scaling.

scaleCenter

A pair of Floats specifying the center of scaling.

objectList

A sequence of ConstrainedSketchGeometry objects to be copied and scaled.

delete(objectList: tuple)[source]#

This method deletes the given ConstrainedSketchGeometry, ConstrainedSketchDimension, or ConstrainedSketchConstraint objects.

Parameters:
objectList

A sequence of ConstrainedSketchGeometry, ConstrainedSketchDimension, or ConstrainedSketchConstraint objects to be deleted.

deleteParameter(name: str)[source]#

The command deletes a specified parameter.

Parameters:
name

A String specifying the name of the parameter to delete.

dragEntity(entity: str, points: tuple)[source]#

This method drags a specified ConstrainedSketchGeometry or ConstrainedSketchVertex object to a specific location.

Parameters:
entity

A ConstrainedSketchGeometry or ConstrainedSketchVertex object specifying the object to drag.

points

A sequence of sequences of three Floats specifying a sequence of points along which to drag the entity. The order of points in the sequence defines a path that determines the solution.

getPointAtDistance(point: tuple[float], distance: str, percentage: BooleanType = 0)[source]#

This method returns a point offset along the given ConstrainedSketchGeometry from the given end by a specified arc length distance or a percentage of the total length of the ConstrainedSketchGeometry object.

Parameters:
point

A pair of Floats specifying the point from which the distance is to be measured.

distance

A float specifying the arc length distance along the ConstrainedSketchGeometry from the point at which the required point is situated.

percentage

A Boolean that specifies if the distance is an absolute distance or is a fraction relative to the length of the ConstrainedSketchGeometry object.

Returns:
points: python:tuple[python:float]

A pair of floats representing the point along the edge

getSize()[source]#

This method returns the length of the given ConstrainedSketchGeometry object.

Returns:
length: python:int

The length of the given ConstrainedSketchGeometry

getVertices()[source]#

This method returns an list of ConstrainedSketchVertex objects which are a part of the given ConstrainedSketchGeometry object.

Returns:
vertices: python:list[ConstrainedSketchVertex]

A list of ConstrainedSketchVertex objects

linearPattern(number1: int, spacing1: float, angle1: float, vertexList: tuple[ConstrainedSketchVertex] = (), geomList: tuple[abaqus.Sketcher.ConstrainedSketchGeometry.ConstrainedSketchGeometry.ConstrainedSketchGeometry] = (), number2: str = 1, spacing2: float | None = None, angle2: float | None = None)[source]#

This method copies ConstrainedSketchGeometry objects in a linear pattern along one or two directions. This method also copies any associated dimension or constraint objects that exist between the given objects.

Parameters:
number1

An Integer specifying the total number of copies, including the original objects, that appear along the first direction in the pattern. Possible values are 1 ≤≤ number1 ≤≤ 1000.

spacing1

A Float specifying the spacing between copies along the first direction in the pattern. Possible values are 0.0 ≤≤ spacing1 .

angle1

A Float specifying the angle in degrees of the first direction in the pattern. Possible values are –360.0 ≤≤ angle1 ≤≤ 360.0.

vertexList

A sequence of ConstrainedSketchVertex objects to copy.

geomList

A sequence of ConstrainedSketchGeometry objects to copy.

number2

An integer specifying the total number of copies, including the original objects, that appear along the second direction in the pattern. Possible values are 1 ≤≤ number2 ≤≤ 1000. The default value is 1. The value of either number1 or number2 must be greater than one.

spacing2

A Float specifying the spacing between copies along the first direction in the pattern. Possible values are 0.0 ≤≤ spacing2. The default value is spacing1.

angle2

A Float specifying the angle in degrees of the first direction in the pattern. Possible values are –360.0 ≤≤ angle2 ≤≤ 360.0. The default value is 90° beyond the value of angle1.

Returns:
None.
Raises:
  • AbaqusException

    Number must be greater than 1 for at least one direction

!img
mergeVertices(value: float, vertexList: tuple[ConstrainedSketchVertex])[source]#

This method merges the ConstrainedSketchVertex objects that lie within the specified distance of each other. If only one ConstrainedSketchVertex object is selected, it will merge all ConstrainedSketchVertex objects that lie within the specified distance of that vertex. If more than one vertex is selected, the search will be restricted to only the selected ConstrainedSketchVertex objects.

Parameters:
value

A Float specifying the search radius.

vertexList

A sequence of ConstrainedSketchVertex objects to be merged.

move(vector: tuple, objectList: tuple[abaqus.Sketcher.ConstrainedSketchGeometry.ConstrainedSketchGeometry.ConstrainedSketchGeometry])[source]#

This method translates the given ConstrainedSketchGeometry objects by the given vector.

Parameters:
vector

A sequence of two Floats specifying the translation vector.

objectList

A sequence of ConstrainedSketchGeometry objects specifying the objects to be translated.

offset(distance: float, objectList: tuple[abaqus.Sketcher.ConstrainedSketchGeometry.ConstrainedSketchGeometry.ConstrainedSketchGeometry], side: SymbolicConstantType, filletCorners: BooleanType = 0)[source]#

This method creates copies of the selected ConstrainedSketchGeometry objects, offsets them by the specified distance in the specified direction, and inserts them into the ConstrainedSketch object’s appropriate repositories. If connected objects are selected, trim or extend is carried out to complete the offset.

Parameters:
distance

A Float specifying the distance to be offset.

objectList

A sequence of ConstrainedSketchGeometry objects to be copied and offset.

side

A SymbolicConstant specifying which side the offset should occur. Possible values are LEFT and RIGHT.

filletCorners

A Boolean specifying whether the corners need to be rounded instead of being extended.

print()[source]#

This method prints the following statistics about a sketch: - The sketch Id (a positive integer). - The number of geometry curves (the number of ConstrainedSketchGeometry objects). - The number of dimensions (the number of ConstrainedSketchDimension objects). - The number of vertices (the number of ConstrainedSketchVertex objects).

radialPattern(number: int, totalAngle: float, centerPoint: tuple[float], vertexList: tuple[ConstrainedSketchVertex] = (), geomList: tuple[abaqus.Sketcher.ConstrainedSketchGeometry.ConstrainedSketchGeometry.ConstrainedSketchGeometry] = ())[source]#

This method copies ConstrainedSketchGeometry objects in a radial pattern about a specified center point.

Parameters:
number

An Int specifying the total number of copies, including the original objects, that appear in the radial pattern. Possible values are 2 ≤≤ number2 ≤≤ 1000.

totalAngle

A Float specifying the total angle in degrees between the first and last instance in the pattern. A positive angle corresponds to a counter-clockwise direction. The values 360° and -360° represent a special case where the pattern makes a full circle. In this case, because the copy would overlay the original, the copy is not placed at the last position. Possible values are –360.0 ≤≤ totalAngle ≤≤ 360.0.

centerPoint

A pair of Floats specifying the center of the radial pattern.

vertexList

A sequence of ConstrainedSketchVertex objects to copy.

geomList

A sequence of ConstrainedSketchGeometry objects to copy.

rectangle(point1: tuple[float], point2: tuple[float])[source]#

This method creates four lines that form a rectangle with diagonal corners defined by the given points and inserts them into the geometry repository of the ConstrainedSketch object.

Parameters:
point1

A pair of Floats specifying the first corner of the rectangle.

point2

A pair of Floats specifying the second corner of the rectangle.

Returns:
success: python:int

An Int specifying the success or failure of the method. A value of 0 indicates failure

removeGapsAndOverlaps(tolerance: str, geomList: tuple[abaqus.Sketcher.ConstrainedSketchGeometry.ConstrainedSketchGeometry.ConstrainedSketchGeometry])[source]#

This method removes gaps and overlaps between sketch geometries specified by the user. This method is particularly useful when cleaning up imported sketches

Parameters:
tolerance

A float value which specifies the largest size of the gap or overlap between entities that is to be removed. Typically this value is small and is used to close gaps and overlaps which may not exist in the originating program but exist in the sketch because of mismatched tolerances between the two programs.

geomList

A sequence of ConstrainedSketchGeometry objects where the gaps and overlaps are to be removed.

repairShortEdges(geomList: tuple[abaqus.Sketcher.ConstrainedSketchGeometry.ConstrainedSketchGeometry.ConstrainedSketchGeometry], tolerance: str = '')[source]#

This method deletes the short edges specified, optionally selecting only those short edges whose lengths are smaller than the specified tolerance and healing the resultant gap in the sketch. This method is particularly useful in conjunction with removeGapsAndOverlap when cleaning up imported sketches.

Parameters:
geomList

A sequence of ConstrainedSketchGeometry objects where the short edges are to be removed.

tolerance

A float value that is used to select and delete only those edges specified in geomList whose lengths are smaller than the given value. The default value is –1.0. This value implies that all edges specified in geomList will be removed and the sketch healed to remove gaps left by their removal.

resetView()[source]#

This method resets the view to be perpendicular to the sketching plane.

retrieveSketch(sketch: ConstrainedSketch)[source]#

This method copies all ConstrainedSketchGeometry, ConstrainedSketchDimension, ConstrainedSketchConstraint, and ConstrainedSketchParameter objects from the specified ConstrainedSketch object. The new objects are added to the existing objects (if any). The objects in the specified ConstrainedSketch object are not modified by the retrieve operation.

Parameters:
sketch

A ConstrainedSketch object specifying the object from which to copy.

rotate(centerPoint: tuple[float], angle: float, objectList: tuple)[source]#

This method rotates the given ConstrainedSketchGeometry objects by the given angle and about the given point.

Parameters:
centerPoint

A pair of Floats specifying the center of rotation.

angle

A Float specifying the angle of rotation in degrees.

objectList

A sequence of ConstrainedSketchGeometry specifying the objects to be rotated.

scale(scaleValue: float, scaleCenter: tuple[float], objectList: tuple[abaqus.Sketcher.ConstrainedSketchGeometry.ConstrainedSketchGeometry.ConstrainedSketchGeometry])[source]#

This method scales the given ConstrainedSketchGeometry objects by the given scale factor and about the given point.

Parameters:
scaleValue

A Float specifying the value of scale.

scaleCenter

A pair of Floats specifying the center of scale.

objectList

A sequence of ConstrainedSketchGeometry objects specifying the objects to be scaled.

setPrimaryObject(option: SymbolicConstantType)[source]#

This method makes the ConstrainedSketch object the primary object in the current viewport. The sketch remains the primary object in the current viewport until an unsetPrimaryobject command is issued.

Parameters:
option

A SymbolicConstant specifying how the sketch is displayed. Possible values are:STANDALONE: Indicates a new stand-alone sketch. The current viewport is cleared and is replaced by the stand-alone sketch. The view direction is set to −ZZ.SUPERIMPOSE: Indicates that the sketch is superimposed on the current viewport. The view direction is changed to be perpendicular to the sketch plane. The change is effected smoothly as an animated sequence of many small viewing steps.

trimExtendCurve(curve1: str, point1: tuple[float], curve2: str, point2: tuple[float])[source]#

This method trims or extends a specified ConstrainedSketchGeometry object (curve1) using another specified ConstrainedSketchGeometry object (curve2). curve2 is not affected by the operation. The location for the trim or extend is determined by the specified point values.

Parameters:
curve1

The ConstrainedSketchGeometry object specifying the object to be trimmed or extended.

point1

A pair of Floats specifying the location on curve1 where trim or extend should be applied.

curve2

The ConstrainedSketchGeometry object specifying the object to which curve1 is trimmed or extended. curve2 is not trimmed or extended.

point2

A pair of Floats specifying the location on curve2 near where curve1 should be trimmed or extended.

undo()[source]#

This method undoes the effects of the last ConstrainedSketch object method.

unsetPrimaryObject()[source]#

This method removes the ConstrainedSketch object from the current viewport, reversing the effects of the setPrimaryobject command. If the option argument was set to SUPERIMPOSE, the viewport will be returned to the view orientation that was in place when the setPrimaryobject command was issued. If the option argument was set to STANDALONE, the viewport will be left empty.

writeAcisFile(fileName: str, version: float | None = None)[source]#

This method exports the geometry of the sketch to a named file in ACIS format.

Parameters:
fileName

A String specifying the file name.

version

A Float specifying the ACIS version. For example, the Float 12.0 corresponds to ACIS Version 12.0. The default value is the current version of ACIS.

writeIgesFile(filename: str, flavor: SymbolicConstantType | None = None)[source]#

This method exports the geometry of the sketch to a named file in IGES format.

Parameters:
filename

A String specifying the file name.

flavor

A SymbolicConstant specifying a particular flavor of IGES to export. Possible values areSTANDARD, AUTOCAD, SOLIDWORKS, JAMA, and MSBO.

CoincidentConstraint#

class CoincidentConstraint(entity1: ConstrainedSketchGeometry, entity2: ConstrainedSketchGeometry)[source]#

ConcentricConstraint#

class ConcentricConstraint(entity1: ConstrainedSketchGeometry, entity2: ConstrainedSketchGeometry)[source]#

ConstrainedSketchConstraint#

class ConstrainedSketchConstraint[source]#

The ConstrainedSketchConstraint object stores the constraints associated with a sketch.

Notes

This object can be accessed by:

import sketch
mdb.models[name].sketches[name].constraints[i]

EqualDistanceConstraint#

class EqualDistanceConstraint(entity1: str, entity2: ConstrainedSketchGeometry, midpoint: Vertex)[source]#

EqualLengthConstraint#

class EqualLengthConstraint(entity1: ConstrainedSketchGeometry, entity2: ConstrainedSketchGeometry)[source]#

EqualRadiusConstraint#

class EqualRadiusConstraint(entity1: ConstrainedSketchGeometry, entity2: str)[source]#

FixedConstraint#

class FixedConstraint(entity: ConstrainedSketchGeometry)[source]#

HorizontalConstraint#

class HorizontalConstraint(entity: ConstrainedSketchGeometry)[source]#

ParallelConstraint#

class ParallelConstraint(entity1: ConstrainedSketchGeometry, entity2: ConstrainedSketchGeometry)[source]#

PerpendicularConstraint#

class PerpendicularConstraint(entity1: ConstrainedSketchGeometry, entity2: ConstrainedSketchGeometry)[source]#

TangentConstraint#

class TangentConstraint(entity1: ConstrainedSketchGeometry, entity2: ConstrainedSketchGeometry)[source]#

VerticalConstraint#

class VerticalConstraint(entity: ConstrainedSketchGeometry)[source]#

AngularDimension#

class AngularDimension(line1: ConstrainedSketchGeometry, line2: ConstrainedSketchGeometry, textPoint: tuple[float], value: float | None = None, reference: BooleanType = 0)[source]#

DistanceDimension#

class DistanceDimension(entity1: ConstrainedSketchVertex, entity2: ConstrainedSketchVertex, textPoint: tuple[float], value: float | None = None, reference: BooleanType = 0)[source]#

HorizontalDimension#

class HorizontalDimension(vertex1: ConstrainedSketchVertex, vertex2: ConstrainedSketchVertex, textPoint: tuple[float], value: float | None = None, reference: BooleanType = 0)[source]#

ObliqueDimension#

class ObliqueDimension(vertex1: ConstrainedSketchVertex, vertex2: ConstrainedSketchVertex, textPoint: tuple[float], value: float | None = None, reference: BooleanType = 0)[source]#

RadialDimension#

class RadialDimension(curve: ConstrainedSketchGeometry, textPoint: tuple[float], value: float | None = None, reference: BooleanType = 0, majorRadius: float | None = None, minorRadius: float | None = None)[source]#

VerticalDimension#

class VerticalDimension(vertex1: ConstrainedSketchVertex, vertex2: ConstrainedSketchVertex, textPoint: tuple[float], value: float | None = None, reference: BooleanType = 0)[source]#

Arc3Points#

class Arc3Points(point1: tuple[float], point2: tuple[float], point3: tuple[float])[source]#

ArcByCenterEnds#

class ArcByCenterEnds(center: tuple[float], point1: tuple[float], point2: tuple[float], direction: SymbolicConstantType)[source]#

ArcByStartEndTangent#

class ArcByStartEndTangent(point1: tuple[float], point2: tuple[float], vector: tuple)[source]#

CircleByCenterPerimeter#

class CircleByCenterPerimeter(center: tuple[float], point1: tuple[float])[source]#

ConstructionCircleByCenterPerimeter#

class ConstructionCircleByCenterPerimeter(center: tuple[float], point1: tuple[float])[source]#

ConstructionLine#

class ConstructionLine(point1: tuple[float], point2: tuple[float])[source]#

EllipseByCenterPerimeter#

class EllipseByCenterPerimeter(center: tuple[float], axisPoint1: tuple[float], axisPoint2: tuple[float])[source]#

FilletByRadius#

class FilletByRadius(radius: float, curve1: ConstrainedSketchGeometry, nearPoint1: tuple[float], curve2: ConstrainedSketchGeometry, nearPoint2: tuple[float])[source]#

getPointAtDistance#

class getPointAtDistance(point: tuple[float], distance: str, percentage: BooleanType = 0)[source]#

Line#

class Line(point1: tuple[float], point2: tuple[float])[source]#

Spline#

class Spline(points: tuple, constrainPoints: BooleanType = True)[source]#

Spot#

class Spot(point: tuple[float])[source]#

ConstrainedSketcherOptions#

class ConstrainedSketcherOptions[source]#

The ConstrainedSketcherOptions object is used to store values and attributes which will be applied to all sketches used in the current session. The ConstrainedSketcherOptions object has no constructor.

Notes

This object can be accessed by:

import sketch
session.sketcherOptions

Methods

setValues([constructionGeometry, gridSnap, ...])

This method modifies the ConstrainedSketchOptions object.

setValues(constructionGeometry: BooleanType = 1, gridSnap: BooleanType = 1, preselection: BooleanType = 1, addImpliedConstraints: BooleanType = 1, maxCoplanarEntities: int = 300, autoConstrainAngularTolerance: float = 0, autoConstrainLinearTolerance: float | None = None, autoConstrainOptions: SymbolicConstantType | None = None, dragMethod: SymbolicConstantType = 'MINIMUM_MOVE', editMethod: SymbolicConstantType = 'STANDARD')[source]#

This method modifies the ConstrainedSketchOptions object.

Parameters:
constructionGeometry

A Boolean specifying whether construction geometry is shown. The default value is ON.

gridSnap

A Boolean specifying whether the cursor snaps to the grid. The default value is ON.

preselection

A Boolean specifying whether geometry will be preselected. The default value is ON.

addImpliedConstraints

A Boolean specifying if implied constraints are added during sketching. The default value is ON.

maxCoplanarEntities

An Int specifying the maximum number of coplanar entities which should be automatically projected from the background, when a sketch based feature is created or edited. When this value is exceeded no entities are automatically projected and a warning issued. Possible values are maxCoplanarEntities >> 0. The default value is 300.

autoConstrainAngularTolerance

A Float specifying the angular tolerance in degrees which is used to determine parallel and tangential conditions during the auto-constrain operation. For example any two lines which have an angle smaller than the given autoConstrainAngularTolerance will be assumed to be parallel, and a parallel constrain may be added during the auto-constrain operation. The default value is 0.01.

autoConstrainLinearTolerance

A Float specifying the linear tolerance which is used to determine when two points or geometries are coincident during the auto-constrain operation. The default value is 10–6.

autoConstrainOptions

A sequence of SymbolicConstants specifying which type of constraints may be added by the auto-constraint tool. Possible values are PARALLEL, PERPENDICULAR, IDENTICAL, TANGENT, CONCENTRIC, and EQUALRADIUS. The default value is (PARALLEL,, PERPENDICULAR,, IDENTICAL,, TANGENT,, CONCENTRIC,, EQUALRADIUS).

dragMethod

A SymbolicConstant specifying the constraint solving mode used by the sketcher during drag operation. Possible values are MINIMUM_MOVE, STANDARD, WEIGHTED, and RELAXATION. The default value is MINIMUM_MOVE.

editMethod

A SymbolicConstant specifying the constraint solving mode used by the sketcher during regular sketch editing and adding new constraints and dimensions. Possible values are MINIMUM_MOVE, STANDARD, WEIGHTED, and RELAXATION. The default value is STANDARD.

Raises:
RangeError

ConstrainedSketchImageOptions#

class ConstrainedSketchImageOptions[source]#

The ConstrainedSketchImageOptions object is used to store values and attributes associated with the background image for a particular sketch. The ConstrainedSketchImageOptions object has no constructor.

Notes

This object can be accessed by:

import sketch
mdb.models[name].sketches[name].imageOptions

Methods

setValues([imageName, showImage, origin, ...])

This method modifies the ConstrainedSketchOptions object.

setValues(imageName: str = '', showImage: BooleanType = 0, origin: tuple[float] = (), xScale: float = 1, yScale: float = 1, translucency: float = 1)[source]#

This method modifies the ConstrainedSketchOptions object.

Parameters:
imageName

A String specifying the name of the image. A list of valid image names is in the images repository in the session object.

showImage

A Boolean specifying whether an image should be displayed in the sketcher background. The default value is OFF.

origin

A pair of Floats specifying the X- and Y-offsets in millimeters from the lower-left corner of the viewport. The default value is (0, 0).

xScale

A Float specifying the scale applied to the image width. The default value is 1.0.When xScale is negative, the image is mirrored about its y-axis but its position is not affected.

yScale

A Float specifying the scale applied to the image height. The default value is 1.0.When yScale is negative, the image is mirrored about its x-axis but its position is not affected.

translucency

A Float specifying the translucency factor to use when displaying the image. Possible values are 0.0 ≤≤ translucency ≤≤ 1.0 with 0.0 being invisible and 1.0 being opaque. The default value is 1.0.

Raises:
RangeError

ConstrainedSketchOptions#

class ConstrainedSketchOptions[source]#

The ConstrainedSketchOptions object is used to store values and attributes associated with a particular sketch. The ConstrainedSketchOptions object has no constructor.

Notes

This object can be accessed by:

import sketch
mdb.models[name].sketches[name].sketchOptions

Methods

setValues([sheetSize, gridSpacing, grid, ...])

This method modifies the ConstrainedSketchOptions object.

setValues(sheetSize: float | None = None, gridSpacing: float | None = None, grid: BooleanType = 1, gridFrequency: int = 1, dimensionTextHeight: float = 12, decimalPlaces: int | None = None, constructionGeometry: BooleanType = 1, gridSnap: BooleanType = 1, preselection: BooleanType = 1, sheetAuto: BooleanType = 1, gridOrigin: tuple = (), gridAngle: float = 0, viewStyle: SymbolicConstantType = 'REGULAR', addImpliedConstraints: BooleanType = 1, maxCoplanarEntities: int = 300, autoConstrainAngularTolerance: float = 0, autoConstrainLinearTolerance: float | None = None, autoConstrainOptions: SymbolicConstantType | None = None, dragMethod: SymbolicConstantType = 'MINIMUM_MOVE', editMethod: SymbolicConstantType = 'STANDARD')[source]#

This method modifies the ConstrainedSketchOptions object.

Parameters:
sheetSize

A Float specifying the sheet size. Possible values are Floats >> 0. The default value is the sheetSize specified with the Sketch method.

gridSpacing

A Float specifying the spacing between gridlines. Possible values are Floats >> 0. The default value is approximately 2.5% of sheetSize.

grid

A Boolean specifying whether the grid is shown. The default value is ON.

gridFrequency

An Int specifying how often gridlines are shown. Possible values are gridFrequency >> 0. The default value is 1.

dimensionTextHeight

A Float specifying the height of the dimension text in points. Possible values are Floats >> 0. The default value is 12.0.

decimalPlaces

An Int specifying how many decimal places are shown in dimensions. Possible values are 0 ≤≤ decimalPlaces ≤≤ 6. The initial value depends on the value of sheetSize.

constructionGeometry

A Boolean specifying whether construction geometry is shown. The default value is ON.

gridSnap

A Boolean specifying whether the cursor snaps to the grid. The default value is ON.

preselection

A Boolean specifying whether geometry will be preselected. The default value is ON.

sheetAuto

A Boolean specifying if the sheet size and the grid spacing are automatically computed. The default value is ON.

gridOrigin

A sequence of Floats specifying the X–Y coordinates for the origin of the grid. The default value is (0, 0).

gridAngle

A Float specifying the angle of the grid relative to the computer screen. The default value is 0.0.

viewStyle

A SymbolicConstant specifying the type of sketch displayed in the viewport. Possible values are REGULAR and AXISYM. The default value is REGULAR.

addImpliedConstraints

A Boolean specifying if implied constraints are added during sketching. The default value is ON.

maxCoplanarEntities

An Int specifying the maximum number of coplanar entities which should be automatically projected from the background, when a sketch based feature is created or edited. When this value is exceeded no entities are automatically projected and a warning issued. Possible values are maxCoplanarEntities >> 0. The default value is 300.

autoConstrainAngularTolerance

A Float specifying the angular tolerance in degrees which is used to determine parallel and tangential conditions during the auto-constrain operation. For example any two lines which have an angle smaller than the given autoConstrainAngularTolerance will be assumed to be parallel, and a parallel constrain may be added during the auto-constrain operation. The default value is 0.01.

autoConstrainLinearTolerance

A Float specifying the linear tolerance which is used to determine when two points or geometries are coincident during the auto-constrain operation. The default value is 10–6.

autoConstrainOptions

A sequence of SymbolicConstants specifying which type of constraints may be added by the auto-constraint tool. Possible values are PARALLEL, PERPENDICULAR, IDENTICAL, TANGENT, CONCENTRIC, and EQUALRADIUS. The default value is (PARALLEL,, PERPENDICULAR,, IDENTICAL,, TANGENT,, CONCENTRIC,, EQUALRADIUS).

dragMethod

A SymbolicConstant specifying the constraint solving mode used by the sketcher during drag operation. Possible values are MINIMUM_MOVE, STANDARD, WEIGHTED, and RELAXATION. The default value is MINIMUM_MOVE.

editMethod

A SymbolicConstant specifying the constraint solving mode used by the sketcher during regular sketch editing and adding new constraints and dimensions. Possible values are MINIMUM_MOVE, STANDARD, WEIGHTED, and RELAXATION. The default value is STANDARD.

Raises:
RangeError

Parameter#

class Parameter(name: str, path: str = '', expression: str = '', previous: str = '')[source]#

ConstrainedSketchVertex#

class ConstrainedSketchVertex[source]#

The ConstrainedSketchVertex object stores the vertex position.

Notes

This object can be accessed by:

import sketch
mdb.models[name].sketches[name].vertices[i]
mdb.models[name].sketches[name].vertices[i][i]
Attributes:
coords

Methods

Spot(point)

This method creates a spot (construction point) located at the specified coordinates.

Spot(point: tuple[float])[source]#

This method creates a spot (construction point) located at the specified coordinates.

Parameters:
point

A pair of Floats specifying the coordinates of the construction point.

Returns:
A ConstrainedSketchVertex object (python:None if the spot cannot be created).

Notes

This function can be accessed by:

mdb.models[name].sketches[name].Spot

ConstrainedSketchVertexArray#

class ConstrainedSketchVertexArray[source]#

The ConstrainedSketchVertexArray is a sequence of ConstrainedSketchVertex objects.

Notes

This object can be accessed by:

import sketch
mdb.models[name].sketches[name].vertices[i]

Methods

findAt(coordinates[, printWarning])

This method returns the ConstrainedSketchVertex located at the given coordinates.

findAt(coordinates: tuple, printWarning: BooleanType = True)[source]#

This method returns the ConstrainedSketchVertex located at the given coordinates.

Parameters:
coordinates

A sequence of Floats specifying the X- and Y-coordinates of the object to find.

printWarning

A Boolean specifying whether a message is to be printed to the CLI if no entity is found at the specified location. The default value is True.

Returns:
A ConstrainedSketchVertex object.

Spot#

class Spot(point: tuple[float])[source]#